unit hiChangeValues;

interface

uses Kol,Share,Debug;

type
  THIChangeValues = class(TDebug)
  
   private
    FList:      PStrList;
    FData:      array of Real;
    FDataCount: integer;
    procedure SetCount(cnt:integer);
    procedure SetText(const Value:string);
  
   public
    In_:array of THI_Event;
    _prop_Type:byte;
    _event_onChange:THI_Event;
        
    constructor Create;
    destructor Destroy; override;

    procedure _work_doChange(var _Data:TData; Index:word);
    procedure _work_doText(var _Data:TData; Index:word);
    procedure Out_(var _Data:TData; Index:word);

    property _prop_Count:integer  write SetCount;
    property _prop_Strings:string write SetText;
  end;

implementation

constructor THIChangeValues.Create;
begin
   inherited Create;
   FList := NewStrList;
end;

destructor THIChangeValues.Destroy;
begin
   FList.Free;
   inherited Destroy;
end;

procedure THIChangeValues.SetText;
begin
   FList.SetText(Value, false);
end;

procedure THIChangeValues.SetCount;
var i:integer;
begin
   SetLength(FData,cnt);
   SetLength(In_,cnt);
   FDataCount := cnt;
end;

procedure THIChangeValues._work_doText;
begin
   FList.SetText(ReadString(_Data, Null), false);
end;

procedure THIChangeValues._work_doChange;
var  i, ind : integer;
     str : string;
     val: real;
begin
    if FDataCount < 1 then exit;
    ind  := ReadInteger(_data,null);
    if ind = -1 then
     for i := 0 To FDataCount - 1 do
      FData[i] := ReadReal(_data,In_[i]) 
    else
     begin
      str := FList.Items[ind];
      for i := 0 To FDataCount - 1 do
       begin
        val := str2Double(GetTok(str, ','));
        FData[i] := ReadReal(_data,In_[i]) + val;               
       end;
     end;
    _hi_OnEvent(_event_onChange,ind);
end;

procedure THIChangeValues.Out_;
begin
    if _prop_Type = 0 then
     dtInteger(_Data, integer(Round(FData[Index])))
    else
     dtReal(_Data, FData[Index])
end;

end.
